#include "paddle.h"

Paddle::Paddle()
{
    pPadding = 10;
    pSpeed = 2;
    rect = {(float)pPadding, 0, 10, 100};
};

Paddle::~Paddle()
{

}

void Paddle::Init()
{
    x = (float)pPadding;
    y = GetScreenHeight()  / 2; 
}

void Paddle::Draw()
{
    // Draw Player Rectangle
    DrawRectangle(rect.startX, rect.startY, rect.width, rect.height, BLUE);
}

void Paddle::Update()
{
    CheckPosition();
    if (IsKeyDown(KEY_UP)) y -= pSpeed; 
    if (IsKeyDown(KEY_DOWN)) y += pSpeed; 

    rect.startY = y - rect.height / 2; 

}; 

void Paddle::CheckPosition()
{
    if (y <= rect.height / 2) {y = rect.height / 2;}

    if (y >= (GetScreenHeight() - rect.height / 2)) {y = GetScreenHeight() - rect.height / 2;}
} 

Rectangle Paddle::getRect()
{
    return {rect.startX, rect.startY, rect.width, rect.height};
}

void CPUPaddle::Init()
{
    x = GetScreenWidth() - (float)pPadding - rect.width;
    y = GetScreenHeight()  / 2; 

    rect.startX = x;
}

void CPUPaddle::Update(float ball_x, float ball_y, float ball_radius)
{
    CheckPosition();

    if (y > ball_y) {y -= pSpeed;}
    if (y < ball_y) {y += pSpeed;}

    rect.startY = y - rect.height / 2;
}
